<?php

namespace App\Models;

use App\Enums\CuttingStatus;
use Illuminate\Database\Eloquent\Attributes\Appends;
use Illuminate\Database\Eloquent\Attributes\Guarded;
use Illuminate\Database\Eloquent\Attributes\Scope;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;
use Spatie\Image\Enums\Fit;
use Spatie\MediaLibrary\HasMedia;
use Spatie\MediaLibrary\InteractsWithMedia;
use Spatie\MediaLibrary\MediaCollections\Models\Media;

#[Appends(['formatted_cost_per_unit', 'status_label', 'formatted_total_material_cost', 'formatted_created_at'])]
#[Guarded(['id'])]
class Cutting extends Model implements HasMedia
{
    use HasFactory, InteractsWithMedia, SoftDeletes;

    protected function casts(): array
    {
        return [
            'status' => CuttingStatus::class,
            'total_material_cost' => 'integer',
            'cost_per_unit' => 'integer',
        ];
    }

    protected function formattedCostPerUnit(): Attribute
    {
        return Attribute::make(
            get: fn () => 'Rp '.number_format($this->cost_per_unit, 0, ',', '.'),
        );
    }

    protected function statusLabel(): Attribute
    {
        return Attribute::make(
            get: fn () => $this->status->label(),
        );
    }

    protected function formattedTotalMaterialCost(): Attribute
    {
        return Attribute::make(
            get: fn () => 'Rp '.number_format($this->total_material_cost, 0, ',', '.'),
        );
    }

    protected function formattedCreatedAt(): Attribute
    {
        return Attribute::make(
            get: fn () => $this->created_at?->translatedFormat('l, d F Y'),
        );
    }

    #[Scope]
    protected function cancelled(Builder $query): void
    {
        $query->where('status', CuttingStatus::CANCELLED);
    }

    #[Scope]
    protected function completed(Builder $query): void
    {
        $query->where('status', CuttingStatus::COMPLETED);
    }

    #[Scope]
    protected function inProgress(Builder $query): void
    {
        $query->where('status', CuttingStatus::IN_PROGRESS);
    }

    public function createdBy(): BelongsTo
    {
        return $this->belongsTo(User::class, 'created_by_id');
    }

    public function cuttingMaterialCombinations(): HasMany
    {
        return $this->hasMany(CuttingMaterialCombination::class);
    }

    public function cuttingMaterials(): HasMany
    {
        return $this->hasMany(CuttingMaterial::class);
    }

    public function cuttingResults(): HasMany
    {
        return $this->hasMany(CuttingResult::class);
    }

    public function registerMediaCollections(): void
    {
        $this->addMediaCollection('photos');
    }

    public function registerMediaConversions(?Media $media = null): void
    {
        $this->addMediaConversion('thumb')
            ->fit(Fit::Contain, 150, 150);
    }
}
